#include <iostream>
#include <fstream>
#include <vector>
#include <sstream>

#include "msgclnt.h"

#define T(_expr) if ((_expr) == false) { std::cerr << c.getLastError() << std::endl; return -1; }
#define CIN(v) std::cout << #v << "\t: "; std::cin >> v

std::string ip;
std::string port;
std::string id;
std::string pw;
std::string phone;
std::string sms;

std::vector<std::string> toList;

int showChat(SConversation & c)
{
	std::cout << "[" << c.sessid << "][" << c.sensitive << "sec] "
			  << c.from << ": " << c.message
			  << std::endl;

	return 0;
}

int newChat(SOpenSession & o)
{
	std::cout << "[" << o.sessid << "] => " << joinStrings(o.idList) << std::endl;
	return 0;
}

bool sendChat(chev & m)
{
	SConversation c;
	std::getline(std::cin, c.message);

	c.from = id;
	c.sensitive = 0;
	c.sessid = m.getSessionID(toList);

	return m.tell(c);
}

int main(int argc, char ** argv)
{
	// declaration
	chev c;
	SCallback cb;

	std::string ini = argv[1];
	std::string tok, to;

	std::ifstream f(ini);

	std::getline(f, ip);
	std::getline(f, port);
	std::getline(f, id);
	std::getline(f, pw);
	std::getline(f, phone);
	std::getline(f, to);

	std::istringstream is(to);
	while (std::getline(is, tok, ','))
		toList.push_back(tok);

	// init
	cb.onListen = showChat;
	cb.onOpenSession = newChat;

	// connect
	T(c.connect(ip, atoi(port.c_str())));
	T(c.listen(cb));
	T(c.sms(phone));

	CIN(sms);
	T(c.join(id, pw, sms));
	std::getline(std::cin, sms);

	T(c.login(id, pw));

	while (true)
	{
		T(sendChat(c));
	}

	return 0;
}
